Class | Sequel::SQL::StringExpression
In: | lib/sequel/sql.rb
Parent: | ComplexExpression

Subclass of ComplexExpression where the expression results in a text/string/varchar value in SQL.

### Methods

like

### Included Modules

StringMethods StringConcatenationMethods InequalityMethods NoBooleanInputMethods

### Constants

LIKE_MAP | = | {[true, true]=>:'~*', [true, false]=>:~, [false, true]=>:ILIKE, [false, false]=>:LIKE} |  | Map of [regexp, case_insenstive] to ComplexExpression operator

### Public Class methods

like(l, *ces)

Creates a SQL pattern match exprssion. left (l) is the SQL string we are matching against, and ces are the patterns we are matching. The match succeeds if any of the patterns match (SQL OR). Patterns can be given as strings or regular expressions. Strings will cause the SQL LIKE operator to be used, and should be supported by most databases. Regular expressions will probably only work on MySQL and PostgreSQL, and SQL regular expression syntax is not fully compatible with ruby regular expression syntax, so be careful if using regular expressions.

The pattern match will be case insensitive if the last argument is a hash with a key of :case_insensitive that is not false or nil. Also, if a case insensitive regular expression is used (//i), that particular pattern which will always be case insensitive.

[Source]

         # File lib/sequel/sql.rb, line 777
    777:       def self.like(l, *ces)
    778:         l, lre, lci = like_element(l)
    779:         lci = (ces.last.is_a?(Hash) ? ces.pop : {})[:case_insensitive] ? true : lci
    780:         ces.collect! do |ce|
    781:           r, rre, rci = like_element(ce)
    782:           BooleanExpression.new(LIKE_MAP[[lre||rre, lci||rci]], l, r)
    783:         end
    784:         ces.length == 1 ? ces.at(0) : BooleanExpression.new(:OR, *ces)
    785:       end

[Validate]